image: registry.gitlab.com/ibm-skills-network/courses/shared-ci/ubuntu:latest

stages:
  - uploading
  - deploy

before_script:
  - ibmcloud login --apikey $IBM_CLOUD_API_KEY -r us-south
  - ibmcloud plugin install cloud-object-storage
  - ibmcloud cos config crn --crn $IBM_COS_RESOURCE_INSTANCE_ID

uploading_warning:
  stage: .pre
  except:
    - master
  script: |
    for f in `find . -type f -not -wholename '*.git*'`
    do
      echo "====== Merging into master will upload and replace $f in IBM COS" 
    done

uploading:
  stage: uploading
  only:
    - master
  variables:
    BASE_URL: ${COS_BUCKET_URL}/${IBM_COS_UPLOAD_PREFIX}${CI_PROJECT_NAME}
  script: |
    for f in `find . -name "*.md" -type f`; do
      echo "Transforming relative URL"
      echo "Asset prefix: ${BASE_URL}"
      echo "$f"
      linkify --file $f --output $f --prefix ${BASE_URL}
    done

    for f in `find . -type f -not -wholename '*.git*'`
    do
      echo "Uploading $f to IBM COS." 
      echo "File Contents:"
      cat $f
      ibmcloud cos upload \
        --bucket ${IBM_COS_BUCKET:-cf-courses-data} \
        --region ${IBM_COS_REGION:-us-geo} \
        --file $f \
        --key ${IBM_COS_UPLOAD_PREFIX}${CI_PROJECT_NAME}/${f/.\//} \
        --content-type application/octet-stream
    done

pages:
  stage: deploy
  only:
    - master
  image: node:12.14.1
  dependencies:
    - uploading
  before_script:
    - git clone --depth=1 https://gitlab.com/ibm-skills-network/ibm-cos-bucket-listing.git
    - cd ibm-cos-bucket-listing
    - yarn install
    - export ASSET_PREFIX=$CI_PAGES_URL
  script:
    - yarn build
    - mv out ../public
    - echo "Site is avaliable at $CI_PAGES_URL"
  artifacts:
    paths:
      - public
